//Sender program
#include <SPI.h>
#include <Mirf.h>
#include <nRF24L01.h>
#include <MirfHardwareSpiDriver.h>

const int x_out = A0;//Pin A0
const int y_out = A1;//pin A1

struct data{
  int xAxis;
  int yAxis;
};
data sensor_data;
int value;

void setup()
{
  Serial.begin(9600);
  Mirf.cePin = 8;
  Mirf.csnPin = 10;
  Mirf.spi = &MirfHardwareSpi;
  Mirf.init();
  Mirf.setRADDR((byte *)"ABCDE"); //Set its own address (the sender address), using 5 characters
  Mirf.payload = sizeof(value);
  Mirf.channel = 90;              //Set up the channel used
  Mirf.config();
}

void loop()
{
  sensor_data.xAxis = analogRead(x_out);
  sensor_data.yAxis = analogRead(y_out);
  
  if(sensor_data.yAxis > 380) {        //go forward
    value = 0x26;
  } else if(sensor_data.xAxis > 380){    //Right turn
    value = 0x27;
  }else if(sensor_data.xAxis <320){      //Left turn   
    value = 0x25;
   }else if(sensor_data.yAxis < 320) {   //Back up
    value = 0x28;
  }else {                               //stop
    value = 0x00;
  }
                
  Serial.println(value);
  Mirf.setTADDR((byte *)"FGHIJ");           //Sets the receiver address
  Mirf.send((byte *)&value);                //Send the instruction, send the random number value
  while(Mirf.isSending());         //Until the send is successful, exit the loop
}
