
/*************************************
 *     TIME:2020.10.27
 *     Development Team: Zhiyi Technology Co., Ltd.
 *     RIGHT WHEEL
 * 
 **************************************/
//define the 74HC595 IO pin
#define SCK 4      //   74HC595-pin 11
#define RCK 7      //   74HC595-pin 12
#define SIN 8      //   74HC595-pin 14
#define EN1 5          
#define EN2 6    

//init the car
void setup() {
 //Set the pin mode
    pinMode(EN1, OUTPUT);
    pinMode(EN2, OUTPUT);
    digitalWrite(EN1,LOW);
    digitalWrite(EN2,LOW);
    pinMode(SCK, OUTPUT);
    pinMode(RCK, OUTPUT);
    pinMode(SIN, OUTPUT);
}

//mian loop
void loop() {
   Motor(57,255,255);//right
}

/* function name: Motor();
 
* Function: change the moving direction and speed of the car through the entry parameters
* Entry parameter 1: movement direction of DRI car
* Input parameters 2~3: Speed1~Speed2 motor speed, value range 0~255
* DRI value description (forward :106;
Back: 149;
Left: 198;
Right: 57.
Stop: 0;
* Return value: None
*/
void Motor(int Dir,int Speed1,int Speed2)
{
    analogWrite(EN1,Speed1); //Motor1 PWM speed regulation
    analogWrite(EN2,Speed2); //Motor2 PWM speed regulation

    //DIR_LATCH sets the low level and writes the direction of movement in preparation
    digitalWrite(RCK,LOW); 
    // Write the Dir direction of motion
    shiftOut(SIN,SCK,MSBFIRST,Dir);
    //DIR_LATCH sets the high level and outputs the direction of movement
    digitalWrite(RCK,HIGH);
}
