
/*************************************
 *     TIME:2020.10.27
 *     Development Team: Zhiyi Technology Co., Ltd.
 *     SPEED
 * 
 * */
//define the 74HC595 IO pin
#define SCK 4      //   74HC595-pin 11
#define RCK 7      //   74HC595-pin 12
#define SIN 8      //   74HC595-pin 14
#define EN1 5          
#define EN2 6      

void setup() {
   //Set the pin mode
    pinMode(EN1, OUTPUT);
    pinMode(EN2, OUTPUT);
    digitalWrite(EN1,LOW);
    digitalWrite(EN2,LOW);
    pinMode(SCK, OUTPUT);
    pinMode(RCK, OUTPUT);
    pinMode(SIN, OUTPUT);
}

void loop() {
  //go forward
  
  //reduce the speed
  for(int i = 255; i >= 0; i--)
  {
     Motor(106,i,i);//forward!
    delay(30);
  }
  delay(1000);
  //stop
  Motor(106,0,0);//speed = 0
  
  delay(1000);

  //runing back
 
  //accelerate
  for(int i = 0; i <= 255; i++){
    Motor(149,i,i);//back
    delay(30);
  }
  
  //stop
   Motor(0,0,0);//back //Motor is off
  delay(2000);
}

/* function name: Motor();
 
* Function: change the moving direction and speed of the car through the entry parameters
* Entry parameter 1: movement direction of DRI car
* Input parameters 2~3: Speed1~Speed2 motor speed, value range 0~255
* DRI value description (forward :106;
Back: 149;
Left: 198;
Right: 57.
Stop: 0;
* Return value: None
*/
void Motor(int Dir,int Speed1,int Speed2)
{
    analogWrite(EN1,Speed1); //Motor1 PWM speed regulation
    analogWrite(EN2,Speed2); //Motor2 PWM speed regulation

    //DIR_LATCH sets the low level and writes the direction of movement in preparation
    digitalWrite(RCK,LOW); 
    // Write the Dir direction of motion
    shiftOut(SIN,SCK,MSBFIRST,Dir);
    //DIR_LATCH sets the high level and outputs the direction of movement
    digitalWrite(RCK,HIGH);
}
