//2021.1.14
// Receiver program
#include <Servo.h>
#include <SPI.h>
#include <Mirf.h>
#include <nRF24L01.h>
#include <MirfHardwareSpiDriver.h>

#define SCK 4       //11
#define RCK 7      //12
#define SIN 8       //14
#define EN1 5          
#define EN2 6       
#define sound        A3   // Define the buzzer pin

int value=0;
void setup()
{
  Serial.begin(9600);
  Mirf.cePin = 10;
  Mirf.csnPin = 9;
  Mirf.spi = &MirfHardwareSpi;
  Mirf.init();
 
  Mirf.setRADDR((byte *)"FGHIJ"); // Set its own address (receiver address), using 5 characters
  Mirf.payload = sizeof(value);   
  Mirf.channel = 90;   // Set the channel to use
  Mirf.config(); 
  Serial.println("Listening...");  // Start listening for received data
    pinMode(EN1, OUTPUT);
    pinMode(EN2, OUTPUT);
  
    pinMode(SCK, OUTPUT);
    pinMode(RCK, OUTPUT);
    pinMode(SIN, OUTPUT);
    pinMode(sound,OUTPUT);
    Motor(57,0,0);
    BEEP();// Set the buzzer to ring once the initialization is complete
}

void loop()
{
  if(Mirf.dataReady()) {  // When the program is received, it outputs the received data from the serial port
    Mirf.getData((byte *) &value);
    Serial.print("Got data: ");
    Serial.println(value);
  }
          if(value==0x26) {        //go forward
            Motor(106,255,255);            
        }else if(value==0x25) {   //Left turn
          Motor(198,255,255);
        } else if(value==0x27){    //Right turn
          Motor(57,255,255);
        }else if(value==0x28){           //Back up
         Motor(149,255,255);
        }else {                                //stop
          Motor(0,255,255);
        }
}


void Motor(int Dir,int Speed1,int Speed2)
{
    analogWrite(EN1,Speed1); // Motor1 PWM speed regulation
    analogWrite(EN2,Speed2); // Motor2 PWM speed regulation

    
    digitalWrite(RCK,LOW); // Dir LATCH sets low level, writes direction of movement to prepare

    shiftOut(SIN,SCK,MSBFIRST,Dir);// Write the Dir direction of motion

    digitalWrite(RCK,HIGH);// Dir LATCH sets the high level to output the direction of motion
}


void BEEP()
{   
    digitalWrite(sound, HIGH);
    delay(500);
    digitalWrite(sound, LOW); 
}
